#!/usr/bin/python
# encoding: UTF-8

import sys
from ply import lex

tokens = ('BRACKETL','BRACKETR',
          'EQ',
          'VAR','NUMBER',
          'COMMA',
          'APPLY','SPACE',
          'ADDOP','SUBOP','MULOP','DIVOP','POWOP',
          'FUNCPOW',
          'LAMBDA','DOT')

t_BRACKETL = '\([ \t]*'
t_BRACKETR = '[ \t]*\)'
t_EQ =       '[ \t]*=[ \t]*'
t_VAR =      r"([a-zA-Z_%$&][a-zA-Z_%0-9$&'`<>\|]*)"
t_COMMA =    '[ \t]*,[ \t]*'
t_APPLY =    '[ \t]*@[ \t]*'
t_SPACE =    '[ \t]+'
t_ADDOP =    '[ \t]*\+[ \t]*'
t_SUBOP =    '[ \t]*-[ \t]*'
t_MULOP =    '[ \t]*\*[ \t]*'
t_DIVOP =    '[ \t]*/[ \t]*'
t_POWOP =    '[ \t]*\^[ \t]*'
t_FUNCPOW =  '[ \t]*![ \t]*'
t_LAMBDA =   r'\\|λ'
t_DOT =      '\.'

# t_ignore = ' \t'

def t_NUMBER(t):
  '[0-9]+'
  try:
    t.value = int(t.value)
  except:
    print "Value of <%s> too big; returning 0." % t.value
    t.value = 0
  return t

def t_error(t):
  print "Illegal char: <%s>." % t.value[0]
  t.skip(1)

lex.lex()

if __name__ == "__main__":
  data = sys.stdin.read()
  lex.input(data)
  while True:
    tok = lex.token()
    if not tok:
      break
    print tok


